require "defines"

script.on_init(onInit)
script.on_load(onLoad)

script.on_event(defines.events.on_preplayer_mined_item, OnRemoved)
script.on_event(defines.events.on_robot_pre_mined, OnRemoved)
script.on_event(defines.events.on_entity_died, OnRemoved)

script.on_event(defines.events.on_built_entity, OnBuilt)
script.on_event(defines.events.on_robot_built_entity, OnBuilt)

-- script.on_event(defines.events.on_tick, onTick)

function onInit()
	global = global or {}
	global.accumulators_mk_ii = global.accumulators_mk_ii or {}
	global.accumulators_mk_iii = global.accumulators_mk_iii or {}
	global.accumulators_mk_iv = global.accumulators_mk_iv or {}
	global.accumulators_mk_ii_max = global.accumulators_mk_ii_max or 0
	global.accumulators_mk_iii_max = global.accumulators_mk_iii_max or 0
	global.accumulators_mk_iv_max = global.accumulators_mk_iv_max or 0
end

function onLoad()
	onInit()
	if #global.accumulators_mk_ii > 0 and #global.accumulators_mk_iii > 0 and #global.accumulators_mk_iv > 0 then
		script.on_event(defines.events.on_tick, onTick)
	end
end

function OnBuilt(event)
	local ent = event.created_entity
	if ent.name == "accumulator-mkII" then
		local obj = {}
		obj.ent = ent
		obj.old = 0
		obj.new = 0
		table.insert(global.accumulators_mk_ii, obj)
	else
		if ent.name == "accumulator-mkIII" then
			local obj = {}
			obj.ent = ent
			obj.old = 0
			obj.new = 0
			table.insert(global.accumulators_mk_iii, obj)
		else
			if ent.name == "accumulator-mkIV" then
				local obj = {}
				obj.ent = ent
				obj.old = 0
				obj.new = 0
				table.insert(global.accumulators_mk_iv, obj)
			end
		end
	end
end

function OnRemoved(event)
	local ent = event.entity
	if ent.name == "accumulator-mkII" then
		for i, accumulator in pairs(global.accumulators_mk_ii) do
			if accumulator.ent == ent then
				table.remove(global.accumulators_mk_ii, i)
			end
		end
	else
		if ent.name == "accumulator-mkIII" then
			for i, accumulator in pairs(global.accumulators_mk_iii) do
				if accumulator.ent == ent then
					table.remove(global.accumulators_mk_iii, i)
				end
			end
		else
			if ent.name == "accumulator-mkIV" then
				for i, accumulator in pairs(global.accumulators_mk_iv) do
					if accumulator.ent == ent then
						table.remove(global.accumulators_mk_iv, i)
					end
				end
			end
		end
	end
end

function onTick(event)
	if #global.accumulators_mk_ii == 0 and #global.accumulators_mk_iii == 0 and #global.accumulators_mk_iv == 0 then
		script.on_event(defines.events.on_tick, nil)
		return
	end
end

function onTickOFF(event)
	if #global.accumulators_mk_ii == 0 and #global.accumulators_mk_iii == 0 and #global.accumulators_mk_iv == 0 then
		script.on_event(defines.events.on_tick, nil)
		return
	end
	
	if #global.accumulators_mk_ii > 0 then
		for i, accumulator in pairs(global.accumulators_mk_ii) do
			local ent = accumulator.ent
			local updateEntity = false
			local toBeUpdated = { }
			accumulator.old = accumulator.new
			accumulator.new = ent.energy
			if accumulator.old == accumulator.new then
				if ent.energy == 0 then
					ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkII-red.png"
					updateEntity = true
				else
					if ent.energy == accumulators_mk_ii_max then
						ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkII-green.png"
						updateEntity = true
					else
						ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkII-orange.png"
						updateEntity = true
					end
				end
			end
			if updateEntity then
				table.insert(toBeUpdated, ent)
				game.regenerate_entity(toBeUpdated)
				table.remove(toBeUpdated, ent)
			end
		end
	end
	
	if #global.accumulators_mk_iii > 0 then
		for i, accumulator in pairs(global.accumulators_mk_iii) do
			local ent = accumulator.ent
			accumulator.old = accumulator.new
			accumulator.new = ent.energy
			if accumulator.old == accumulator.new then
				if ent.energy == 0 then
					ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkIII-red.png"
				else
					if ent.energy == accumulators_mk_iii_max then
						ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkIII-green.png"
					else
						ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkIII-orange.png"
					end
				end
			end
		end
	end
	
	if #global.accumulators_mk_iv > 0 then
		for i, accumulator in pairs(global.accumulators_mk_iv) do
			local ent = accumulator.ent
			accumulator.old = accumulator.new
			accumulator.new = ent.energy
			if accumulator.old == accumulator.new then
				if ent.energy == 0 then
					ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkIV-red.png"
				else
					if ent.energy == accumulators_mk_iv_max then
						ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkIV-green.png"
					else
						ent.picture.filename = "__AdvancedAccumulators__/graphics/entity/adv-accumulator-mkIV-orange.png"
					end
				end
			end
		end
	end
end
